#ifndef _VDIBIND_H
#define _VDIBIND_H
    
#ifndef _COMPILER_H
# include "compiler.h"
#endif
    
#ifdef __cplusplus
extern "C" {
#endif

#ifndef _SIZE_T
#  include <stddef.h>
#endif

#ifdef VDI_LOCAL
#define __VWHERE 
#else
#define __VWHERE extern
#endif


__VWHERE WORD	 vswr_mode __PROTO((WORD handle, WORD mode));
__VWHERE void	 vs_color __PROTO((WORD handle, WORD index, WORD rgb[]));
__VWHERE WORD	 vsl_type __PROTO((WORD handle, WORD style));
__VWHERE void	 vsl_udsty __PROTO((WORD handle, WORD pat));
__VWHERE WORD	 vsl_width __PROTO((WORD handle, WORD width));
__VWHERE WORD	 vsl_color __PROTO((WORD handle, WORD index));
__VWHERE void	 vsl_ends __PROTO((WORD handle, WORD begstyle, WORD endstyle));
__VWHERE WORD	 vsm_type __PROTO((WORD handle, WORD symbol));
__VWHERE void	 vsm_height __PROTO((WORD handle, WORD height));
__VWHERE WORD	 vsm_color __PROTO((WORD handle, WORD index));
__VWHERE WORD 	 vst_height __PROTO((WORD handle, WORD height, WORD *charw,
				     WORD *charh, WORD *cellw, WORD *cellh));
__VWHERE WORD	 vst_point __PROTO((WORD handle, WORD point, WORD *charw,
				    WORD *charh, WORD *cellw, WORD *cellh));
__VWHERE WORD	 vst_rotation __PROTO((WORD handle, WORD ang));
__VWHERE WORD	 vst_font __PROTO((WORD handle, WORD font));
__VWHERE WORD	 vst_color __PROTO((WORD handle, WORD index));
__VWHERE WORD	 vst_effects __PROTO((WORD handle, WORD effects));
__VWHERE void	 vst_alignment __PROTO((WORD handle, WORD hin, WORD vin,
					WORD *hout, WORD *vout)); 
__VWHERE WORD	 vsf_interior __PROTO((WORD handle, WORD style));
__VWHERE WORD	 vsf_fill __PROTO((WORD handle, WORD style));
__VWHERE WORD	 vsf_style __PROTO((WORD handle, WORD style));
__VWHERE WORD	 vsf_color __PROTO((WORD handle, WORD index));
__VWHERE WORD	 vsf_perimeter __PROTO((WORD handle, WORD vis));
__VWHERE void	 vsf_udpat __PROTO((WORD handle, WORD pat[], WORD planes));


__VWHERE void	 v_opnwk __PROTO((WORD work_in[], WORD *handle, WORD work_out[]));
__VWHERE void	 v_clswk __PROTO((WORD handle));
__VWHERE void	 v_opnvwk __PROTO((WORD work_in[], WORD *handle, WORD work_out[]));
__VWHERE void	 v_clsvwk __PROTO((WORD handle));


__VWHERE void	 v_clrwk __PROTO((WORD handle));
__VWHERE void	 v_updwk __PROTO((WORD handle));
__VWHERE WORD	 vst_load_fonts __PROTO((WORD handle, WORD select));
__VWHERE void	 vst_unload_fonts __PROTO((WORD handle, WORD select));
__VWHERE void	 vs_clip __PROTO((WORD handle, WORD clip_flag, WORD pxyarray[]));


__VWHERE void	 v_bar __PROTO((WORD handle, WORD pxyarray[]));
__VWHERE void	 v_arc __PROTO((WORD handle, WORD x, WORD y, WORD radius,
				WORD begang, WORD endang)); 
__VWHERE void	 v_pieslice __PROTO((WORD handle, WORD x, WORD y, WORD radius,
				     WORD begang, WORD endang));
__VWHERE void	 v_circle __PROTO((WORD handle, WORD x, WORD y, WORD radius));
__VWHERE void	 v_ellarc __PROTO((WORD handle, WORD x, WORD y, WORD xrad,
				   WORD yrad, WORD begang, WORD endang));
__VWHERE void	 v_ellpie __PROTO((WORD handle, WORD x, WORD y, WORD xrad,
				   WORD yrad, WORD begang, WORD endang));
__VWHERE void	 v_ellipse __PROTO((WORD handle, WORD x, WORD y, WORD xrad, WORD yrad));
__VWHERE void	 v_rbox __PROTO((WORD handle, WORD pxyarray[]));
__VWHERE void	 v_rfbox __PROTO((WORD handle, WORD pxyarray[]));
__VWHERE void	 v_justified __PROTO((WORD handle, WORD x, WORD y, char *str,
				      WORD len, WORD word_space, WORD char_space));

__VWHERE WORD	 vsin_mode  __PROTO((WORD handle, WORD dev, WORD mode));
__VWHERE void	 vrq_locator __PROTO((WORD handle, WORD x, WORD y, WORD *xout,
				      WORD *yout, WORD *term));  
__VWHERE WORD	 vsm_locator __PROTO((WORD handle, WORD x, WORD y, WORD *xout,
				      WORD *yout, WORD *term));

__VWHERE void	 vrq_valuator __PROTO((WORD handle, WORD in, WORD *out, WORD *term));
__VWHERE void	 vsm_valuator __PROTO((WORD handle, WORD in, WORD *out, WORD *term,
				       WORD *status));
__VWHERE void	 vrq_choice __PROTO((WORD handle, WORD cin, WORD *cout));
__VWHERE WORD	 vsm_choice __PROTO((WORD handle, WORD *choice));
__VWHERE void	 vrq_string __PROTO((WORD handle, WORD len, WORD echo,
				     WORD echoxy[], char *str));
__VWHERE WORD	 vsm_string __PROTO((WORD handle, WORD len, WORD echo,
				     WORD echoxy[], char *str));
__VWHERE void	 vsc_form __PROTO((WORD handle, WORD form[]));
__VWHERE void	 vex_timv __PROTO((WORD handle, void *time_addr,
				   void **otime_addr, WORD *time_conv)); 
__VWHERE void	 v_show_c __PROTO((WORD handle, WORD reset));
__VWHERE void	 v_hide_c __PROTO((WORD handle));
__VWHERE void 	 vq_mouse __PROTO((WORD handle, WORD *pstatus, WORD *x, WORD *y));
__VWHERE void	 vex_butv __PROTO((WORD handle, void *new_p, void **old));
__VWHERE void	 vex_motv __PROTO((WORD handle, void *new_p, void **old));
__VWHERE void	 vex_curv __PROTO((WORD handle, void *new_p, void **old));
__VWHERE void	 vq_key_s __PROTO((WORD handle, WORD *state));


__VWHERE void	 vq_extnd __PROTO((WORD handle, WORD flag, WORD work_out[]));
__VWHERE WORD	 vq_color __PROTO((WORD handle, WORD index, WORD flag, WORD rgb[]));
__VWHERE void	 vql_attribute __PROTO((WORD handle, WORD atrib[]));
__VWHERE void	 vqm_attributes __PROTO((WORD handle, WORD atrib[]));
__VWHERE void	 vqf_attributes __PROTO((WORD handle, WORD atrib[]));
__VWHERE void	 vqt_attributes __PROTO((WORD handle, WORD atrib[]));
__VWHERE void	 vqt_extent __PROTO((WORD handle, char *str, WORD extent[]));
__VWHERE WORD	 vqt_width __PROTO((WORD handle, WORD chr, WORD *cw, WORD *ldelta,
				    WORD *rdelta));
__VWHERE WORD	 vqt_name __PROTO((WORD handle, WORD element, char *name));
__VWHERE void	 vq_cellarray __PROTO((WORD handle, WORD pxyarray[], WORD row_len,
				       WORD nrows, WORD *el_used, WORD *rows_used,
				       WORD *status, WORD color[]));  
__VWHERE void	 vqin_mode __PROTO((WORD handle, WORD dev, WORD *mode));
__VWHERE void	 vqt_fontinfo __PROTO((WORD handle, WORD *minade, WORD *maxade,
				       WORD distances[], WORD *maxwidth,
				       WORD effects[]));  
__VWHERE void	 vqt_font_info __PROTO((WORD handle, WORD *minade, WORD *maxade,
					WORD distances[], WORD *maxwidth,
					WORD effects[]));  


__VWHERE void	 v_pline __PROTO((WORD handle, WORD count, WORD pxyarray[]));
__VWHERE void	 v_pmarker __PROTO((WORD handle, WORD count, WORD pxyarray[]));
__VWHERE WORD	 v_gtext __PROTO((WORD handle, WORD x, WORD y, char *str));
__VWHERE void	 v_fillarea __PROTO((WORD handle, WORD count, WORD pxyarray[]));
__VWHERE void	 v_cellarray __PROTO((WORD handle, WORD pxyarray[],
				      WORD row_length, WORD elements, WORD nrows,
				      WORD write_mode, WORD colarray[]));
__VWHERE void	 v_contourfill __PROTO((WORD handle, WORD x, WORD y, WORD index));
__VWHERE void	 vr_recfl __PROTO((WORD handle, WORD pxyarray[]));


__VWHERE void	 vro_cpyfm __PROTO((WORD handle, WORD mode, WORD pxyarray[],
				    void *src, void *dst));
__VWHERE void	 vrt_cpyfm __PROTO((WORD handle, WORD mode, WORD pxyarray[],
				    void *src, void *dst, WORD color[]));  
__VWHERE void	 vr_trnfm __PROTO((WORD handle, void *src, void *dst));
__VWHERE void	 v_get_pixel __PROTO((WORD handle, WORD x, WORD y, WORD *pel,
				      WORD *indx)); 

/* Verbose headers. They do seem to leave out the fact that the character
 * coordinates are from (1, 1) (top left corner..).
 */

/*		vq_chcells
 * Inquire addressable Alpha character cells.
 * -1 for no cursor addressing (value for `*n_cols' ? )
 */
__VWHERE void vq_chcells __PROTO((WORD handle, WORD *n_rows, WORD *n_cols));

/*		v_exit_cur
 * Exit alpha mode.
 */
__VWHERE void v_exit_cur __PROTO((WORD handle));


/*		v_enter_cur
 * Enter alpha mode
 */
__VWHERE void v_enter_cur __PROTO((WORD handle));

/*		v_curup
 * Alpha cursor up (do nothing if at top).
 */
__VWHERE void v_curup __PROTO((WORD handle));

/*		v_curdown
 * Alpha cursor down (do nothing if at bottom).
 */
__VWHERE void v_curdown __PROTO((WORD handle));

/*		v_curright
 * Alpha cursor right (do nothing if at right edge).
 */
__VWHERE void v_curright __PROTO((WORD handle));

/*		v_curleft
 * Alpha cursor left (do nothing if at left edge).
 */
__VWHERE void v_curleft __PROTO((WORD handle));

/*		v_curhome
 * Alpha cursor home.
 */
__VWHERE void v_curhome __PROTO((WORD handle));

/*		v_eeos
 * Erase to end of screen.
 */
__VWHERE void v_eeos __PROTO((WORD handle));

/*		v_eeol
 * Erase to end of line.
 */
__VWHERE void v_eeol __PROTO((WORD handle));

/*		vs_curaddress
 * Direct set position.
 */
__VWHERE void vs_curaddress __PROTO((WORD handle, WORD row, WORD col));

/*		v_curtext
 * Output cursor addressable text (string `s').
 */
__VWHERE void v_curtext __PROTO((WORD handle, char *s));

/*		v_rvon
 * Reverse video on.
 */
__VWHERE void v_rvon __PROTO((WORD handle));

/*		v_rvoff
 * Reverse video off
 */
__VWHERE void v_rvoff __PROTO((WORD handle));

/*		vq_curaddress
 * Inquire current cursor address.
 */
__VWHERE void vq_curaddress __PROTO((WORD handle, WORD *cur_row, WORD *cur_col));

/*
 * more vdi esc bindings
 */
__VWHERE WORD  vq_tabstatus __PROTO((WORD handle));
__VWHERE void v_hardcopy __PROTO((WORD handle));
__VWHERE void v_dspcur  __PROTO((WORD handle, WORD x, WORD y));
__VWHERE void v_rmcur __PROTO((WORD handle));
__VWHERE void v_form_adv __PROTO((WORD handle));
__VWHERE void v_output_window __PROTO((WORD handle, WORD *pxyarray));
__VWHERE void v_clear_disp_list __PROTO((WORD handle));
__VWHERE void v_bit_image __PROTO((WORD handle, const char *filename,
			WORD aspect, WORD x_scale,
			WORD y_scale, WORD h_align, WORD v_align,
			WORD *pxyarray));
__VWHERE void vq_scan __PROTO((WORD handle, WORD *g_slice, WORD *g_page,
		WORD *a_slice, WORD *a_page, WORD *div_fac));
__VWHERE void v_alpha_text __PROTO((WORD handle, const char *string));
__VWHERE WORD  vs_palette __PROTO(( WORD handle, WORD palette));
__VWHERE void v_sound __PROTO((WORD handle, WORD frequency, WORD duration));
__VWHERE WORD  vs_mute __PROTO((WORD handle, WORD action));
__VWHERE void vt_resolution __PROTO(( WORD handle, WORD xres, WORD yres,
			WORD *xset, WORD *yset));
__VWHERE void vt_axis __PROTO((WORD handle, WORD xres, WORD yres, WORD *xset,
			WORD *yset));
__VWHERE void vt_origin __PROTO((WORD handle, WORD xorigin, WORD yorigin));
__VWHERE void vq_dimensions __PROTO((WORD handle, WORD *xdimension,
		WORD *ydimension));
__VWHERE void vt_alignment __PROTO((WORD handle, WORD dx, WORD dy));
__VWHERE void vsp_film __PROTO((WORD handle, WORD index, WORD lightness));
__VWHERE WORD  vqp_filmname __PROTO((WORD handle, WORD index, char *name));
__VWHERE void vsc_expose __PROTO((WORD handle, WORD state));
__VWHERE void v_meta_extents __PROTO((WORD handle, WORD min_x, WORD min_y,
		WORD max_x, WORD max_y));
__VWHERE void v_write_meta __PROTO((WORD handle, WORD num_intin, WORD *a_intin, WORD num_ptsin,
			WORD *a_ptsin));
__VWHERE void vm_pagesize __PROTO((WORD handle, WORD pgwidth, WORD pgheight));
__VWHERE void vm_coords __PROTO((WORD handle, WORD llx, WORD lly, WORD urx,
		WORD ury));
__VWHERE void vm_filename __PROTO((WORD handle, const char *filename));
__VWHERE void v_escape2000 __PROTO((WORD handle, WORD times));

/* is gdos present */

/* return values for vq_vgdos() inquiry */
#define GDOS_NONE -2L		/* no GDOS installed */
#define GDOS_FSM  0x5F46534DL	/* '_FSM' */
#define GDOS_FNT  0x5F464E54L	/* '_FNT' */

#ifdef __GNUC_INLINE__
#define vq_vgdos()				\
({						\
	register unsigned long ret __asm__("d0");	\
	__asm__ volatile			\
	("					\
		movq	#-2,d0;			\
		trap	#2 "			\
	: "=r"(ret)				/* output */ \
	:					\
	: "d0", "d1", "d2", "a0", "a1", "a2"	/* clobbered regs */ \
	);					\
	ret;					\
})
#else 
__VWHERE unsigned long vq_gdos __PROTO((void));
#endif /* __GNUC__ | !__NO_INLINE__ */	

/* FSM/SpeedGDOS bindings */

/* Get Character Bitmap Information. This call provides information to allow
 * the caller to know the exact size and placement of a given character.  This
 * information includes the character's x and y advance vectors, the x and y
 * offsets, and the bitmap dimensions of the character. The advance vector
 * represents the amount to add to the current point to place the following
 * character.  The x and y offsets, when added to the current point, give the
 * caller the location of the upper left hand corner of the bitmap.  The width
 * and height of the bitmap are returned as 16 bit integers.  All other values
 * are returned in fix31 representation.
 */
__VWHERE void v_getbitmap_info __PROTO((WORD handle, WORD ch,  long *advancex,
long *advancey, long *xoffset, long *yoffset, WORD *width, WORD *height,
short **bitmap));


/*
 * Inquire text extent, accounting for FSM text placement
 */
__VWHERE void vqt_f_extent __PROTO((WORD handle, const char *str, WORD extent[]));

/*
 * Draw outline font text (accounts for fractional advances in rotated text)
 */
__VWHERE void v_ftext __PROTO((WORD handle, WORD x, WORD y, const char *str));
__VWHERE void v_ftext_offset __PROTO((WORD handle, WORD x, WORD y,
                                      const char *str, WORD *offset)); 

/*
 * Generate an outline for character ch, and return the address of the outline.
 */
__VWHERE void v_getoutline __PROTO((WORD handle, WORD ch, WORD *xyarray,
                                 char *bezarray, WORD maxverts, WORD *numverts));

/*
 * Set scratch buffer allocation mode.
 * mode=0: (default) account for FSM fonts when allocating scratch buffers
 * mode=1: account only for BM fonts
 * mode=2: allocate no scratch buffer
 */
__VWHERE void vst_scratch __PROTO((WORD handle, WORD mode));

/*
 * Set FSM error mode.
 * mode=1: (default) errors go to screen.
 * mode=0: errors reported in error variable `errorvar'.
 *   NOTICE: the pointer for errorvar is a pointer to short
 *           (in 32 bit mode it would make a difference)
 */
__VWHERE void vst_error __PROTO((WORD handle, WORD mode, short *errorvar));

/*
 * v_gtext with optional shadow attribute
 */
__VWHERE void	v_shtext __PROTO(( WORD wsid, WORD x, WORD y, const char *text,
				  WORD color, WORD xshadow, WORD yshadow ));

/*
 * Set character cell height by arbitrary points.
 */
__VWHERE WORD	vst_arbpt __PROTO((  WORD handle, WORD point, WORD *wchar,
				   WORD *hchar, WORD *wcell, WORD *hcell ));
__VWHERE long	vst_arbpt32 __PROTO((  WORD handle, long point, WORD *wchar,
				   WORD *hchar, WORD *wcell, WORD *hcell ));

/*
 * Inquire outline font text advance placement vector.
 */
__VWHERE void	vqt_advance __PROTO(( WORD handle, WORD ch, WORD *xadv,
				     WORD *yadv, WORD *xrem, WORD *yrem)); 
__VWHERE void   vqt_advance32 __PROTO((WORD handle, WORD ch, long *advx,
                                       long *advy));

/*
 * Inquire device status information.
 */
__VWHERE void	vqt_devinfo __PROTO(( WORD handle, WORD device, WORD *isdev,
				     char *drivername ));

/*
 * Save FSM cache to disk.
 */
__VWHERE WORD	v_savecache __PROTO(( WORD handle, char *filename ));

/*
 * Load/merge FSM cache from disk.
 */
__VWHERE WORD	v_loadcache __PROTO(( WORD handle, char *filename, WORD mode ));

/*
 * Flush FSM cache.
 */
__VWHERE WORD	v_flushcache __PROTO(( WORD handle ));

/*
 * Set character cell width by arbitrary points.
 */
__VWHERE WORD	vst_setsize __PROTO(( WORD handle, WORD point, WORD *wchar,
				     WORD *hchar, WORD *wcell, WORD *hcell ));
__VWHERE long	vst_setsize32 __PROTO(( WORD handle, long point, WORD *wchar,
				     WORD *hchar, WORD *wcell, WORD *hcell ));

/*
 * Set FSM skew.
 */
__VWHERE WORD	vst_skew __PROTO(( WORD handle, WORD skew ));

/*
 * Get FSM GASCII tables.
 */
__VWHERE void   vqt_get_table __PROTO((WORD handle, short **map));
#if 0 /* old FSMgdos binding */
__VWHERE void	vqt_get_tables __PROTO(( WORD handle, void **gascii,
					void **style ));
#endif

/* 
 * Get FSM cache size
 */
__VWHERE void	vqt_cachesize __PROTO(( WORD handle, WORD which_cache,
				       size_t *size ));
/*
 * Set Character Mapping Mode
 */
__VWHERE void vst_charmap __PROTO((WORD handle, WORD mode));

/*
 * Set Kerning Mode
 */
__VWHERE void vst_kern __PROTO((WORD handle, WORD tmode, WORD pmode, WORD *tracks,
                                WORD *pairs));

/*
 * Inq Speedo Header
 */
__VWHERE void vqt_fontheader __PROTO((WORD handle, char *buffer, char
                                      *pathname));

/*
 * Inq track kerning info
 */
__VWHERE void vqt_trackkern __PROTO((WORD handle, long *x, long *y));

/*
 * Inq pair kerning info
 */
__VWHERE void vqt_pairkern __PROTO((WORD handle, WORD ch1, WORD ch2, long *x, long
                                    *y));

/*
 * bezier curves stuff
 */
__VWHERE void v_set_app_buff __PROTO((void **buf_p, WORD size));

__VWHERE WORD v_bez __PROTO((WORD handle, WORD count,
			    	 WORD *xyarr, char *bezarr,
				 WORD extent[4], WORD *npts, WORD *nmvs));
__VWHERE WORD v_bez_fill __PROTO((WORD handle, WORD count,
				 WORD *xyarr, char *bezarr,
				 WORD extent[4], WORD *npts, WORD *nmvs));
__VWHERE WORD v_bez_qual __PROTO((WORD handle, WORD percent, WORD *actual));

#ifdef ALTERNATE

/* Use these #defines if you _really_ want to stick to DRI conventions */

__VWHERE WORD v_bez_con __PROTO((WORD handle, WORD onoff));
#define v_bez_on(x)	(WORD)v_bez_con((x), 1)
#define v_bez_off(x)	(void)v_bez_con((x), 0)

#else
__VWHERE WORD v_bez_on __PROTO((WORD handle));
__VWHERE void v_bez_off __PROTO((WORD handle));
#endif /* ALTERNATE */

#ifdef __cplusplus
}
#endif

#endif /* _VDIBIND_H */
