/*
 * Functions for dealing with the user moving a window to a new location
 */

#include "gemx.h"

void GEMmoveWindow(int win)
	{
	/* Called with the mouse pressed down, and over the topbar of the
	 * window to be moved
	 */
	WORD x  = GEMwins[win].ax;
	WORD y  = GEMwins[win].ay;
	WORD w  = GEMwins[win].aw;
	WORD h  = GEMwins[win].ah;

	WORD dX = 0;
	WORD dY = 0;
	WORD dH = GEMDeskH;
	WORD dW = GEMDeskW;

	WORD oX, oY;

	graf_dragbox(w,h,x,y, dX, dY, dW, dH, &oX, &oY);
	GEMdoMoveWindow(win, oX, oY);
	}

void GEMdoMoveWindow(int win, WORD x, WORD y)
	{
	/* Actually does the window move, calls X with the correct parameters
	 */

	GEMwins[win].ax = x;
	GEMwins[win].ay = y;
	XMoveWindow(display, GEMwins[win].win, x, y);
	}

